package payroll2;

public class BasePlusCommissionSalary implements Salary {

	private BaseSalary base;
	private CommissionedSalary commission;
	
	public BasePlusCommissionSalary(BaseSalary base, CommissionedSalary commission) {
		this.base = base;
		this.commission = commission;
	}
	
	@Override
	public double getTotal() {
		return base.getTotal() + commission.getTotal();
	}

	@Override
	public void accept(SalaryVisitor visitor) {
		visitor.visit(this);
		base.accept(visitor);
		commission.accept(visitor);
	}

	public BaseSalary getBaseSalary() {
		return base;
	}
	
	public CommissionedSalary getCommissionSalary() {
		return commission;
	}

}
