package payroll2;

public class CommissionEmployee extends Employee {

	private CommissionedSalary salary;
	
	public CommissionEmployee(String firstName, String lastName, int id, double commissionRate, double totalSales) {
		this(firstName, lastName, id, new CommissionedSalary(commissionRate, totalSales));
	}
	
	protected CommissionEmployee(String firstName, String lastName, int id, CommissionedSalary salary) {
		super(firstName, lastName, id);
		
		this.salary = salary;
	}

	protected CommissionedSalary getCommissionedSalary() {
		return salary;
	}
	
	@Override
	public Salary getSalary() {
		return salary;
	}
	
	@Override
	public String toString() {
		return String.format("commissioned employee: %s\ngross sales: $%.2f;\ncommission rate: %.2f",
				super.toString(), salary.getTotalSales(), salary.getCommissionRate());
	}

}
