package payroll2;

public abstract class Employee {

	private String firstName;
	private String lastName;
	private int id;

	public Employee(String firstName, String lastName, int id) {
		this.firstName = firstName;
		this.lastName = lastName;
		this.id = id;
	}

	public String getFirstName() {
		return firstName;
	}
	
	public String getLastName() {
		return lastName;
	}
	
	public int getId() {
		return id;
	}
	
	/**
	 * Return the employee's weekly earnings
	 */
	public double getEarnings() {
		return getSalary().getTotal();
	}
	
	public abstract Salary getSalary();

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return String.format("%s %s\nID: %d", getFirstName(), getLastName(), getId());
	}
}
