package payroll2;

public class HourlySalary implements Salary {
	protected static final int WEEK = 40;
	protected static final double OVERTIME_FACTOR = 1.5;
	
	private int hours;
	private double rate;
	
	public HourlySalary(int hours, double rate) {
		this.hours = hours;
		this.rate = rate;
	}

	public double getRate() {
		return rate;
	}
	
	public int getHours() {
		return hours;
	}
	
	@Override
	public double getTotal() {
		return getWorkingHours() * rate + 
				getOvertime() * rate * OVERTIME_FACTOR;
	}

	private int getOvertime() {
		return Math.max(0, hours-WEEK);
	}

	private int getWorkingHours() {
		return Math.min(hours, WEEK);
	}

	@Override
	public void accept(SalaryVisitor visitor) {
		visitor.visit(this);
	}

	public void raise(double d) {
		this.rate += d;
	}
}
