package payroll2;

import java.util.ArrayList;
import java.util.List;

public class PayrollSystemTest {

	public static void main(String[] args) {
		payrollSystemTest();
	}

	public static void printPayrollReport(Employee... employees) {
		for (Employee employee : employees) {
			System.out.println(employee + "\nearned $" + employee.getEarnings()
					+ "\n");
		}
	}

	public static void printPayrollReport(List<Employee> employees) {
		printPayrollReport(employees.toArray(new Employee[0]));
	}

	public static void payrollSystemTest() {
		List<Employee> employees = new ArrayList<Employee>();

		createEmployees(employees);

		System.out.println("Week 1");
		printPayrollReport(employees);

		System.out.println("Week 2");
		for (Employee e : employees)
			e.getSalary().accept(new SalaryVisitorAdapter() {
				@Override
				public void visit(HourlySalary salary) {
					salary.raise(salary.getRate() * 0.1);
				}
			});
		
		printPayrollReport(employees);

		System.out.println("Week 3");
		for (Employee e : employees) {
			e.getSalary().accept(new SalaryVisitorAdapter() {
				@Override
				public void visit(BaseSalary salary) {
					salary.raise(salary.getBaseAmount() * 0.05);
				}
			});
		}
		printPayrollReport(employees);

		System.out.println("Week 4");
		for (Employee e : employees) {
			e.getSalary().accept(new SalaryVisitorAdapter() {
				@Override
				public void visit(CommissionedSalary salary) {
					salary.raise(0.01);
				}
			});
		}
		printPayrollReport(employees);
	}

	private static void createEmployees(List<Employee> employees) {
		employees.add(new SalariedEmployee("John", "Lennon", 1, 1000));
		employees.add(new SalariedEmployee("Paul", "McCartney", 2, 1000));
		employees.add(new HourlyEmployee("George", "Harrison", 3, 10, 30));
		employees.add(new HourlyEmployee("Ringo", "Starr", 4, 10, 50));
		employees.add(new CommissionEmployee("Jerry", "Seinfeld", 5, 0.1, 200));
		employees.add(new CommissionEmployee("Elaine", "Benes", 6, 0.5, 100));
		employees.add(new BasePlusCommissionEmployee("Kosmo", "Kramer", 7, 0.1,
				100, 500));
		employees.add(new BasePlusCommissionEmployee("George", "Kostanza", 8,
				0.5, 100, 500));
	}
}
